Bug 892983 (CVE-2013-0160)

Summary: CVE-2013-0160 kernel: /dev/ptmx to measure inter-keystroke timing
Product: [Other] Security Response Reporter: Jan Lieskovsky <jlieskov>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED WONTFIX QA Contact:
Severity: low Docs Contact:
Priority: low    
Version: unspecifiedCC: agordeev, davej, dhoward, fhrbata, gansalmon, iboverma, itamar, jforbes, jneedle, jonathan, jrusnack, jwboyer, kernel-maint, kernel-mgr, lwang, madhu.chinakonda, mcressma, mrg-program-list, nobody, plougher, pmatouse, rvrbovsk, sforsber
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=low,public=20130107,reported=20130107,source=oss-security,cvss2=2.1/AV:L/AC:L/Au:N/C:P/I:N/A:N,rhel-5/kernel=affected,rhel-6/kernel=affected,mrg-2/realtime-kernel=affected,fedora-all/kernel=affected,cwe=CWE-385
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-11-21 05:34:47 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 892984    
Attachments:
Description Flags
Local copy of the reproducer to determine keystroke latency
none
Local copy of a reproducer to determine password length for "su -" session none

Description Jan Lieskovsky 2013-01-08 06:11:02 EST
A security flaw was found in the way "/dev/ptmx", a character device used to create a pseudo-terminal master (PTM) and slave (PTS) pair, of the Linux kernel, used to transmit data through the PTM when a keystroke was pressed. An unprivileged, local user could use this flaw to determine inter-keystroke timing (measure latency between keystrokes), possibly allowing them to determine effective length of an password being typed in.

References:
[1] http://vladz.devzero.fr/013_ptmx-timing.php
[2] http://users.ece.cmu.edu/~dawnsong/papers/ssh-timing.pdf
[3] http://www.openwall.com/lists/oss-security/2013/01/07/5
[4] https://bugzilla.novell.com/show_bug.cgi?id=797175

Reproducers:
[5] http://vladz.devzero.fr/svn/codes/PoC/ptmx-keystroke-latency.c
    (to display latency between keystrokes)
[6] http://vladz.devzero.fr/svn/codes/PoC/ptmx-su-pwdlen.sh
    (to determine password length)


This issue was found by researcher with nickname vladz.
Comment 1 Jan Lieskovsky 2013-01-08 06:13:02 EST
Created attachment 674721 [details]
Local copy of the reproducer to determine keystroke latency
Comment 2 Jan Lieskovsky 2013-01-08 06:13:57 EST
Created attachment 674722 [details]
Local copy of a reproducer to determine password length for "su -" session
Comment 3 Martin Prpic 2014-11-21 05:34:47 EST
Statement:

This issue affects the versions of the Linux kernel as shipped with Red Hat Enterprise Linux 5 and 6, and Red Hat Enterprise MRG 2. Red Hat Product Security has rated this issue as having Low security impact. This issue is not currently planned to be addressed in future updates. For additional information, refer to the Issue Severity Classification: https://access.redhat.com/security/updates/classification/